git-submodule.shon commit submodule update: Don't fetch when the submodule commit is already present (e5f522d)
   1#!/bin/sh
   2#
   3# git-submodules.sh: add, init, update or list git submodules
   4#
   5# Copyright (c) 2007 Lars Hjemli
   6
   7dashless=$(basename "$0" | sed -e 's/-/ /')
   8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
   9   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
  10   or: $dashless [--quiet] init [--] [<path>...]
  11   or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
  12   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
  13   or: $dashless [--quiet] foreach [--recursive] <command>
  14   or: $dashless [--quiet] sync [--] [<path>...]"
  15OPTIONS_SPEC=
  16. git-sh-setup
  17. git-parse-remote
  18require_work_tree
  19
  20command=
  21branch=
  22force=
  23reference=
  24cached=
  25recursive=
  26init=
  27files=
  28nofetch=
  29update=
  30prefix=
  31
  32# Resolve relative url by appending to parent's url
  33resolve_relative_url ()
  34{
  35        remote=$(get_default_remote)
  36        remoteurl=$(git config "remote.$remote.url") ||
  37                die "remote ($remote) does not have a url defined in .git/config"
  38        url="$1"
  39        remoteurl=${remoteurl%/}
  40        sep=/
  41        while test -n "$url"
  42        do
  43                case "$url" in
  44                ../*)
  45                        url="${url#../}"
  46                        case "$remoteurl" in
  47                        */*)
  48                                remoteurl="${remoteurl%/*}"
  49                                ;;
  50                        *:*)
  51                                remoteurl="${remoteurl%:*}"
  52                                sep=:
  53                                ;;
  54                        *)
  55                                die "cannot strip one component off url '$remoteurl'"
  56                                ;;
  57                        esac
  58                        ;;
  59                ./*)
  60                        url="${url#./}"
  61                        ;;
  62                *)
  63                        break;;
  64                esac
  65        done
  66        echo "$remoteurl$sep${url%/}"
  67}
  68
  69#
  70# Get submodule info for registered submodules
  71# $@ = path to limit submodule list
  72#
  73module_list()
  74{
  75        git ls-files --error-unmatch --stage -- "$@" | sane_grep '^160000 '
  76}
  77
  78#
  79# Map submodule path to submodule name
  80#
  81# $1 = path
  82#
  83module_name()
  84{
  85        # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
  86        re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
  87        name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
  88                sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
  89       test -z "$name" &&
  90       die "No submodule mapping found in .gitmodules for path '$path'"
  91       echo "$name"
  92}
  93
  94#
  95# Clone a submodule
  96#
  97# Prior to calling, cmd_update checks that a possibly existing
  98# path is not a git repository.
  99# Likewise, cmd_add checks that path does not exist at all,
 100# since it is the location of a new submodule.
 101#
 102module_clone()
 103{
 104        path=$1
 105        url=$2
 106        reference="$3"
 107
 108        if test -n "$reference"
 109        then
 110                git-clone "$reference" -n "$url" "$path"
 111        else
 112                git-clone -n "$url" "$path"
 113        fi ||
 114        die "Clone of '$url' into submodule path '$path' failed"
 115}
 116
 117#
 118# Add a new submodule to the working tree, .gitmodules and the index
 119#
 120# $@ = repo path
 121#
 122# optional branch is stored in global branch variable
 123#
 124cmd_add()
 125{
 126        # parse $args after "submodule ... add".
 127        while test $# -ne 0
 128        do
 129                case "$1" in
 130                -b | --branch)
 131                        case "$2" in '') usage ;; esac
 132                        branch=$2
 133                        shift
 134                        ;;
 135                -f | --force)
 136                        force=$1
 137                        ;;
 138                -q|--quiet)
 139                        GIT_QUIET=1
 140                        ;;
 141                --reference)
 142                        case "$2" in '') usage ;; esac
 143                        reference="--reference=$2"
 144                        shift
 145                        ;;
 146                --reference=*)
 147                        reference="$1"
 148                        shift
 149                        ;;
 150                --)
 151                        shift
 152                        break
 153                        ;;
 154                -*)
 155                        usage
 156                        ;;
 157                *)
 158                        break
 159                        ;;
 160                esac
 161                shift
 162        done
 163
 164        repo=$1
 165        path=$2
 166
 167        if test -z "$path"; then
 168                path=$(echo "$repo" |
 169                        sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 170        fi
 171
 172        if test -z "$repo" -o -z "$path"; then
 173                usage
 174        fi
 175
 176        # assure repo is absolute or relative to parent
 177        case "$repo" in
 178        ./*|../*)
 179                # dereference source url relative to parent's url
 180                realrepo=$(resolve_relative_url "$repo") || exit
 181                ;;
 182        *:*|/*)
 183                # absolute url
 184                realrepo=$repo
 185                ;;
 186        *)
 187                die "repo URL: '$repo' must be absolute or begin with ./|../"
 188        ;;
 189        esac
 190
 191        # normalize path:
 192        # multiple //; leading ./; /./; /../; trailing /
 193        path=$(printf '%s/\n' "$path" |
 194                sed -e '
 195                        s|//*|/|g
 196                        s|^\(\./\)*||
 197                        s|/\./|/|g
 198                        :start
 199                        s|\([^/]*\)/\.\./||
 200                        tstart
 201                        s|/*$||
 202                ')
 203        git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
 204        die "'$path' already exists in the index"
 205
 206        if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
 207        then
 208                echo >&2 "The following path is ignored by one of your .gitignore files:" &&
 209                echo >&2 $path &&
 210                echo >&2 "Use -f if you really want to add it."
 211                exit 1
 212        fi
 213
 214        # perhaps the path exists and is already a git repo, else clone it
 215        if test -e "$path"
 216        then
 217                if test -d "$path"/.git -o -f "$path"/.git
 218                then
 219                        echo "Adding existing repo at '$path' to the index"
 220                else
 221                        die "'$path' already exists and is not a valid git repo"
 222                fi
 223
 224                case "$repo" in
 225                ./*|../*)
 226                        url=$(resolve_relative_url "$repo") || exit
 227                    ;;
 228                *)
 229                        url="$repo"
 230                        ;;
 231                esac
 232                git config submodule."$path".url "$url"
 233        else
 234
 235                module_clone "$path" "$realrepo" "$reference" || exit
 236                (
 237                        clear_local_git_env
 238                        cd "$path" &&
 239                        # ash fails to wordsplit ${branch:+-b "$branch"...}
 240                        case "$branch" in
 241                        '') git checkout -f -q ;;
 242                        ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
 243                        esac
 244                ) || die "Unable to checkout submodule '$path'"
 245        fi
 246
 247        git add $force "$path" ||
 248        die "Failed to add submodule '$path'"
 249
 250        git config -f .gitmodules submodule."$path".path "$path" &&
 251        git config -f .gitmodules submodule."$path".url "$repo" &&
 252        git add --force .gitmodules ||
 253        die "Failed to register submodule '$path'"
 254}
 255
 256#
 257# Execute an arbitrary command sequence in each checked out
 258# submodule
 259#
 260# $@ = command to execute
 261#
 262cmd_foreach()
 263{
 264        # parse $args after "submodule ... foreach".
 265        while test $# -ne 0
 266        do
 267                case "$1" in
 268                -q|--quiet)
 269                        GIT_QUIET=1
 270                        ;;
 271                --recursive)
 272                        recursive=1
 273                        ;;
 274                -*)
 275                        usage
 276                        ;;
 277                *)
 278                        break
 279                        ;;
 280                esac
 281                shift
 282        done
 283
 284        toplevel=$(pwd)
 285
 286        module_list |
 287        while read mode sha1 stage path
 288        do
 289                if test -e "$path"/.git
 290                then
 291                        say "Entering '$prefix$path'"
 292                        name=$(module_name "$path")
 293                        (
 294                                prefix="$prefix$path/"
 295                                clear_local_git_env
 296                                cd "$path" &&
 297                                eval "$@" &&
 298                                if test -n "$recursive"
 299                                then
 300                                        cmd_foreach "--recursive" "$@"
 301                                fi
 302                        ) ||
 303                        die "Stopping at '$path'; script returned non-zero status."
 304                fi
 305        done
 306}
 307
 308#
 309# Register submodules in .git/config
 310#
 311# $@ = requested paths (default to all)
 312#
 313cmd_init()
 314{
 315        # parse $args after "submodule ... init".
 316        while test $# -ne 0
 317        do
 318                case "$1" in
 319                -q|--quiet)
 320                        GIT_QUIET=1
 321                        ;;
 322                --)
 323                        shift
 324                        break
 325                        ;;
 326                -*)
 327                        usage
 328                        ;;
 329                *)
 330                        break
 331                        ;;
 332                esac
 333                shift
 334        done
 335
 336        module_list "$@" |
 337        while read mode sha1 stage path
 338        do
 339                # Skip already registered paths
 340                name=$(module_name "$path") || exit
 341                url=$(git config submodule."$name".url)
 342                test -z "$url" || continue
 343
 344                url=$(git config -f .gitmodules submodule."$name".url)
 345                test -z "$url" &&
 346                die "No url found for submodule path '$path' in .gitmodules"
 347
 348                # Possibly a url relative to parent
 349                case "$url" in
 350                ./*|../*)
 351                        url=$(resolve_relative_url "$url") || exit
 352                        ;;
 353                esac
 354
 355                git config submodule."$name".url "$url" ||
 356                die "Failed to register url for submodule path '$path'"
 357
 358                upd="$(git config -f .gitmodules submodule."$name".update)"
 359                test -z "$upd" ||
 360                git config submodule."$name".update "$upd" ||
 361                die "Failed to register update mode for submodule path '$path'"
 362
 363                say "Submodule '$name' ($url) registered for path '$path'"
 364        done
 365}
 366
 367#
 368# Update each submodule path to correct revision, using clone and checkout as needed
 369#
 370# $@ = requested paths (default to all)
 371#
 372cmd_update()
 373{
 374        # parse $args after "submodule ... update".
 375        orig_flags=
 376        while test $# -ne 0
 377        do
 378                case "$1" in
 379                -q|--quiet)
 380                        GIT_QUIET=1
 381                        ;;
 382                -i|--init)
 383                        init=1
 384                        ;;
 385                -N|--no-fetch)
 386                        nofetch=1
 387                        ;;
 388                -r|--rebase)
 389                        update="rebase"
 390                        ;;
 391                --reference)
 392                        case "$2" in '') usage ;; esac
 393                        reference="--reference=$2"
 394                        orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 395                        shift
 396                        ;;
 397                --reference=*)
 398                        reference="$1"
 399                        ;;
 400                -m|--merge)
 401                        update="merge"
 402                        ;;
 403                --recursive)
 404                        recursive=1
 405                        ;;
 406                --)
 407                        shift
 408                        break
 409                        ;;
 410                -*)
 411                        usage
 412                        ;;
 413                *)
 414                        break
 415                        ;;
 416                esac
 417                orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 418                shift
 419        done
 420
 421        if test -n "$init"
 422        then
 423                cmd_init "--" "$@" || return
 424        fi
 425
 426        module_list "$@" |
 427        while read mode sha1 stage path
 428        do
 429                name=$(module_name "$path") || exit
 430                url=$(git config submodule."$name".url)
 431                update_module=$(git config submodule."$name".update)
 432                if test -z "$url"
 433                then
 434                        # Only mention uninitialized submodules when its
 435                        # path have been specified
 436                        test "$#" != "0" &&
 437                        say "Submodule path '$path' not initialized" &&
 438                        say "Maybe you want to use 'update --init'?"
 439                        continue
 440                fi
 441
 442                if ! test -d "$path"/.git -o -f "$path"/.git
 443                then
 444                        module_clone "$path" "$url" "$reference"|| exit
 445                        subsha1=
 446                else
 447                        subsha1=$(clear_local_git_env; cd "$path" &&
 448                                git rev-parse --verify HEAD) ||
 449                        die "Unable to find current revision in submodule path '$path'"
 450                fi
 451
 452                if ! test -z "$update"
 453                then
 454                        update_module=$update
 455                fi
 456
 457                if test "$subsha1" != "$sha1"
 458                then
 459                        force=
 460                        if test -z "$subsha1"
 461                        then
 462                                force="-f"
 463                        fi
 464
 465                        if test -z "$nofetch"
 466                        then
 467                                # Run fetch only if $sha1 isn't present or it
 468                                # is not reachable from a ref.
 469                                (clear_local_git_env; cd "$path" &&
 470                                        ((rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
 471                                         test -z "$rev") || git-fetch)) ||
 472                                die "Unable to fetch in submodule path '$path'"
 473                        fi
 474
 475                        case "$update_module" in
 476                        rebase)
 477                                command="git rebase"
 478                                action="rebase"
 479                                msg="rebased onto"
 480                                ;;
 481                        merge)
 482                                command="git merge"
 483                                action="merge"
 484                                msg="merged in"
 485                                ;;
 486                        *)
 487                                command="git checkout $force -q"
 488                                action="checkout"
 489                                msg="checked out"
 490                                ;;
 491                        esac
 492
 493                        (clear_local_git_env; cd "$path" && $command "$sha1") ||
 494                        die "Unable to $action '$sha1' in submodule path '$path'"
 495                        say "Submodule path '$path': $msg '$sha1'"
 496                fi
 497
 498                if test -n "$recursive"
 499                then
 500                        (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
 501                        die "Failed to recurse into submodule path '$path'"
 502                fi
 503        done
 504}
 505
 506set_name_rev () {
 507        revname=$( (
 508                clear_local_git_env
 509                cd "$1" && {
 510                        git describe "$2" 2>/dev/null ||
 511                        git describe --tags "$2" 2>/dev/null ||
 512                        git describe --contains "$2" 2>/dev/null ||
 513                        git describe --all --always "$2"
 514                }
 515        ) )
 516        test -z "$revname" || revname=" ($revname)"
 517}
 518#
 519# Show commit summary for submodules in index or working tree
 520#
 521# If '--cached' is given, show summary between index and given commit,
 522# or between working tree and given commit
 523#
 524# $@ = [commit (default 'HEAD'),] requested paths (default all)
 525#
 526cmd_summary() {
 527        summary_limit=-1
 528        for_status=
 529        diff_cmd=diff-index
 530
 531        # parse $args after "submodule ... summary".
 532        while test $# -ne 0
 533        do
 534                case "$1" in
 535                --cached)
 536                        cached="$1"
 537                        ;;
 538                --files)
 539                        files="$1"
 540                        ;;
 541                --for-status)
 542                        for_status="$1"
 543                        ;;
 544                -n|--summary-limit)
 545                        if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
 546                        then
 547                                :
 548                        else
 549                                usage
 550                        fi
 551                        shift
 552                        ;;
 553                --)
 554                        shift
 555                        break
 556                        ;;
 557                -*)
 558                        usage
 559                        ;;
 560                *)
 561                        break
 562                        ;;
 563                esac
 564                shift
 565        done
 566
 567        test $summary_limit = 0 && return
 568
 569        if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
 570        then
 571                head=$rev
 572                test $# = 0 || shift
 573        elif test -z "$1" -o "$1" = "HEAD"
 574        then
 575                # before the first commit: compare with an empty tree
 576                head=$(git hash-object -w -t tree --stdin </dev/null)
 577                test -z "$1" || shift
 578        else
 579                head="HEAD"
 580        fi
 581
 582        if [ -n "$files" ]
 583        then
 584                test -n "$cached" &&
 585                die "--cached cannot be used with --files"
 586                diff_cmd=diff-files
 587                head=
 588        fi
 589
 590        cd_to_toplevel
 591        # Get modified modules cared by user
 592        modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
 593                sane_egrep '^:([0-7]* )?160000' |
 594                while read mod_src mod_dst sha1_src sha1_dst status name
 595                do
 596                        # Always show modules deleted or type-changed (blob<->module)
 597                        test $status = D -o $status = T && echo "$name" && continue
 598                        # Also show added or modified modules which are checked out
 599                        GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 600                        echo "$name"
 601                done
 602        )
 603
 604        test -z "$modules" && return
 605
 606        git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
 607        sane_egrep '^:([0-7]* )?160000' |
 608        cut -c2- |
 609        while read mod_src mod_dst sha1_src sha1_dst status name
 610        do
 611                if test -z "$cached" &&
 612                        test $sha1_dst = 0000000000000000000000000000000000000000
 613                then
 614                        case "$mod_dst" in
 615                        160000)
 616                                sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
 617                                ;;
 618                        100644 | 100755 | 120000)
 619                                sha1_dst=$(git hash-object $name)
 620                                ;;
 621                        000000)
 622                                ;; # removed
 623                        *)
 624                                # unexpected type
 625                                echo >&2 "unexpected mode $mod_dst"
 626                                continue ;;
 627                        esac
 628                fi
 629                missing_src=
 630                missing_dst=
 631
 632                test $mod_src = 160000 &&
 633                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
 634                missing_src=t
 635
 636                test $mod_dst = 160000 &&
 637                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
 638                missing_dst=t
 639
 640                total_commits=
 641                case "$missing_src,$missing_dst" in
 642                t,)
 643                        errmsg="  Warn: $name doesn't contain commit $sha1_src"
 644                        ;;
 645                ,t)
 646                        errmsg="  Warn: $name doesn't contain commit $sha1_dst"
 647                        ;;
 648                t,t)
 649                        errmsg="  Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
 650                        ;;
 651                *)
 652                        errmsg=
 653                        total_commits=$(
 654                        if test $mod_src = 160000 -a $mod_dst = 160000
 655                        then
 656                                range="$sha1_src...$sha1_dst"
 657                        elif test $mod_src = 160000
 658                        then
 659                                range=$sha1_src
 660                        else
 661                                range=$sha1_dst
 662                        fi
 663                        GIT_DIR="$name/.git" \
 664                        git rev-list --first-parent $range -- | wc -l
 665                        )
 666                        total_commits=" ($(($total_commits + 0)))"
 667                        ;;
 668                esac
 669
 670                sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
 671                sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
 672                if test $status = T
 673                then
 674                        if test $mod_dst = 160000
 675                        then
 676                                echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
 677                        else
 678                                echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
 679                        fi
 680                else
 681                        echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
 682                fi
 683                if test -n "$errmsg"
 684                then
 685                        # Don't give error msg for modification whose dst is not submodule
 686                        # i.e. deleted or changed to blob
 687                        test $mod_dst = 160000 && echo "$errmsg"
 688                else
 689                        if test $mod_src = 160000 -a $mod_dst = 160000
 690                        then
 691                                limit=
 692                                test $summary_limit -gt 0 && limit="-$summary_limit"
 693                                GIT_DIR="$name/.git" \
 694                                git log $limit --pretty='format:  %m %s' \
 695                                --first-parent $sha1_src...$sha1_dst
 696                        elif test $mod_dst = 160000
 697                        then
 698                                GIT_DIR="$name/.git" \
 699                                git log --pretty='format:  > %s' -1 $sha1_dst
 700                        else
 701                                GIT_DIR="$name/.git" \
 702                                git log --pretty='format:  < %s' -1 $sha1_src
 703                        fi
 704                        echo
 705                fi
 706                echo
 707        done |
 708        if test -n "$for_status"; then
 709                if [ -n "$files" ]; then
 710                        echo "# Submodules changed but not updated:"
 711                else
 712                        echo "# Submodule changes to be committed:"
 713                fi
 714                echo "#"
 715                sed -e 's|^|# |' -e 's|^# $|#|'
 716        else
 717                cat
 718        fi
 719}
 720#
 721# List all submodules, prefixed with:
 722#  - submodule not initialized
 723#  + different revision checked out
 724#
 725# If --cached was specified the revision in the index will be printed
 726# instead of the currently checked out revision.
 727#
 728# $@ = requested paths (default to all)
 729#
 730cmd_status()
 731{
 732        # parse $args after "submodule ... status".
 733        orig_flags=
 734        while test $# -ne 0
 735        do
 736                case "$1" in
 737                -q|--quiet)
 738                        GIT_QUIET=1
 739                        ;;
 740                --cached)
 741                        cached=1
 742                        ;;
 743                --recursive)
 744                        recursive=1
 745                        ;;
 746                --)
 747                        shift
 748                        break
 749                        ;;
 750                -*)
 751                        usage
 752                        ;;
 753                *)
 754                        break
 755                        ;;
 756                esac
 757                orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 758                shift
 759        done
 760
 761        module_list "$@" |
 762        while read mode sha1 stage path
 763        do
 764                name=$(module_name "$path") || exit
 765                url=$(git config submodule."$name".url)
 766                displaypath="$prefix$path"
 767                if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
 768                then
 769                        say "-$sha1 $displaypath"
 770                        continue;
 771                fi
 772                set_name_rev "$path" "$sha1"
 773                if git diff-files --ignore-submodules=dirty --quiet -- "$path"
 774                then
 775                        say " $sha1 $displaypath$revname"
 776                else
 777                        if test -z "$cached"
 778                        then
 779                                sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
 780                                set_name_rev "$path" "$sha1"
 781                        fi
 782                        say "+$sha1 $displaypath$revname"
 783                fi
 784
 785                if test -n "$recursive"
 786                then
 787                        (
 788                                prefix="$displaypath/"
 789                                clear_local_git_env
 790                                cd "$path" &&
 791                                eval cmd_status "$orig_args"
 792                        ) ||
 793                        die "Failed to recurse into submodule path '$path'"
 794                fi
 795        done
 796}
 797#
 798# Sync remote urls for submodules
 799# This makes the value for remote.$remote.url match the value
 800# specified in .gitmodules.
 801#
 802cmd_sync()
 803{
 804        while test $# -ne 0
 805        do
 806                case "$1" in
 807                -q|--quiet)
 808                        GIT_QUIET=1
 809                        shift
 810                        ;;
 811                --)
 812                        shift
 813                        break
 814                        ;;
 815                -*)
 816                        usage
 817                        ;;
 818                *)
 819                        break
 820                        ;;
 821                esac
 822        done
 823        cd_to_toplevel
 824        module_list "$@" |
 825        while read mode sha1 stage path
 826        do
 827                name=$(module_name "$path")
 828                url=$(git config -f .gitmodules --get submodule."$name".url)
 829
 830                # Possibly a url relative to parent
 831                case "$url" in
 832                ./*|../*)
 833                        url=$(resolve_relative_url "$url") || exit
 834                        ;;
 835                esac
 836
 837                say "Synchronizing submodule url for '$name'"
 838                git config submodule."$name".url "$url"
 839
 840                if test -e "$path"/.git
 841                then
 842                (
 843                        clear_local_git_env
 844                        cd "$path"
 845                        remote=$(get_default_remote)
 846                        git config remote."$remote".url "$url"
 847                )
 848                fi
 849        done
 850}
 851
 852# This loop parses the command line arguments to find the
 853# subcommand name to dispatch.  Parsing of the subcommand specific
 854# options are primarily done by the subcommand implementations.
 855# Subcommand specific options such as --branch and --cached are
 856# parsed here as well, for backward compatibility.
 857
 858while test $# != 0 && test -z "$command"
 859do
 860        case "$1" in
 861        add | foreach | init | update | status | summary | sync)
 862                command=$1
 863                ;;
 864        -q|--quiet)
 865                GIT_QUIET=1
 866                ;;
 867        -b|--branch)
 868                case "$2" in
 869                '')
 870                        usage
 871                        ;;
 872                esac
 873                branch="$2"; shift
 874                ;;
 875        --cached)
 876                cached="$1"
 877                ;;
 878        --)
 879                break
 880                ;;
 881        -*)
 882                usage
 883                ;;
 884        *)
 885                break
 886                ;;
 887        esac
 888        shift
 889done
 890
 891# No command word defaults to "status"
 892test -n "$command" || command=status
 893
 894# "-b branch" is accepted only by "add"
 895if test -n "$branch" && test "$command" != add
 896then
 897        usage
 898fi
 899
 900# "--cached" is accepted only by "status" and "summary"
 901if test -n "$cached" && test "$command" != status -a "$command" != summary
 902then
 903        usage
 904fi
 905
 906"cmd_$command" "$@"